package de.unirostock.Bridge.Schlange.webapplet;

import java.awt.Graphics;
import java.awt.Label;
import de.unirostock.Bridge.Schlange.*;

public class PaintDoppVerkSchlange extends AbstrPaintSchlange {

	static PaintDoppVerkSchlange defaultInstance = null;
	static Label appLabel;
	static KonkrSchlange schlange;

    public static PaintDoppVerkSchlange getDefault(Label l, KonkrSchlange s) {
        if (defaultInstance == null)
        {
            defaultInstance = new PaintDoppVerkSchlange();
        }
        appLabel = l;
        schlange = s;
        return defaultInstance;
    }

	public void paintSchlange(Graphics g, int abstand){
    	appLabel.setText("Doppelt verkettete Schlange: " + schlange.getAnzahl() + " Elemente");
    	char c;
    	char[] elemente = schlange.getSchlangeImplementierer().getAsArray();
    	for (int i=0; i<schlange.getAnzahl(); i++) {
    		if (i==0) {
	   			// begin-Pfeil
	   			g.drawLine(584 - abstand,140, 584 - abstand, 130);
	   			g.drawLine(584 - abstand,140, 580 - abstand, 136);
	   			g.drawLine(584 - abstand,140, 588 - abstand, 136);
	   			g.drawString("begin", 568 - abstand, 123);
	   		}
    		c = elemente[i];
    		g.drawString(String.valueOf(c), 580 - i*50 - abstand,160);
    		g.drawLine(572 - i*50 - abstand,145,596 - i*50 - abstand, 145);//oben waagerecht
    		g.drawLine(572 - i*50 - abstand,168,596 - i*50 - abstand, 168);//unten waagerecht
    		g.drawLine(572 - i*50 - abstand,145,572 - i*50 - abstand, 168);//linke Seite
    		g.drawLine(596 - i*50 - abstand,145,596 - i*50 - abstand, 168);//rechte Seite
    		//linker Pfeil
    		g.drawLine(547 - i*50 - abstand,160,572 - i*50 - abstand, 160);
    		g.drawLine(546 - i*50 - abstand,160,555 - i*50 - abstand, 164);
    		g.drawLine(546 - i*50 - abstand,160,555 - i*50 - abstand, 156);
    		//rechter Pfeil
    		g.drawLine(596 - i*50 - abstand,152,622 - i*50 - abstand, 152);
    		g.drawLine(622 - i*50 - abstand,152,612 - i*50 - abstand, 156);
    		g.drawLine(622 - i*50 - abstand,152,612 - i*50 - abstand, 148);
    	}
    }

	public void paintRemoveAnimation(Graphics g, char c){
		int x= 572;
		int y= 145;//115
		for (int i = 1; i<11; i++){
			g.clearRect(295,70,705,100);
			WebApp.drawPapierkorb(g);
			paintSchlange(g, 50-i*5);
			if (i<8){
				paintElem(g, c, x+i*19, y-i*8);
			} else if (i==10){
				paintElem(g, c, 743, 140);//110
			} else {
				paintElem(g, c, x+i*19, y-(10-i)*30);
			}
	   		WebApp.verzoegern();
		}
	}

	public void paintInsertAnimation(Graphics g, char c){
		int anz = schlange.getAnzahl();
		int ende = 572 - 50*anz;
		for (int i = 0; i<10; i++){
			g.clearRect(175,70,546-175-(anz-1)*50,100);
			paintElem(g, c, 210 + (ende - 210)/10*i, 145);
	   		WebApp.verzoegern();
		}
	}
	
	public void paintElem(Graphics g, char c, int x, int y) {
   		g.drawString(String.valueOf(c), x+8,y+15);
		g.drawLine(x,    y,    x+24, y);//oben waagerecht
   		g.drawLine(x,    y+23, x+24, y+23);// unten waagerecht
   		g.drawLine(x,    y,    x,    y+23);//linke Seite
   		g.drawLine(x+24, y,    x+24, y+23);//rechte Seite
	}

}
